Index: src/perl/ldapweb.cgi
===================================================================
--- src/perl/ldapweb.cgi	(revision 4079)
+++ src/perl/ldapweb.cgi	(revision 4080)
@@ -27,32 +27,45 @@
 # account for Metacat access.  We currently only support LDAP even
 # though metacat could potentially support other types of directories.
 #
-use strict;       # turn on strict syntax checking.
-use Template;     # load the template-toolkit module.
-use CGI;          # load the CGI module. 
-use Net::LDAP;    # load the LDAP net libraries
-use Net::SMTP;    # load the SMTP net libraries
-use Digest::SHA1; # for creating the password hash
-use MIME::Base64; # for creating the password hash
-use URI;          # for parsing URL syntax
-use AppConfig qw(:expand :argcount);
+use strict;             # turn on strict syntax checking
+use Template;           # load the template-toolkit module
+use CGI;                # load the CGI module 
+use Net::LDAP;          # load the LDAP net libraries
+use Net::SMTP;          # load the SMTP net libraries
+use Digest::SHA1;       # for creating the password hash
+use MIME::Base64;       # for creating the password hash
+use URI;                # for parsing URL syntax
+use Config::Properties; # for parsing Java .properties files
+use File::Basename;     # for path name parsing
 
-# Set up our default configuration
-my $ldapurl = "@ldapurl@";
-my $mainldapurl = "@ldapurl@";
-my $root = "@user@";
-my $rootpw = "@password@";
-my $searchBase = "@ldapSearchBase@";
-my $templatesDir = "@templates.dir@";
-my $mailhost = "@mailhost@";
-my $sender = "@sender@";
-my $TIMEOUT = 20;
-my $mainldapdownmessage = "The main ldap server " . $mainldapurl . " is down!";
+# Global configuration paramters
+my $cgiUrl = $ENV{'SCRIPT_FILENAME'};
+my $workingDirectory = dirname($cgiUrl);
+my $metacatProps = "${workingDirectory}/../WEB-INF/metacat.properties";
+my $properties = new Config::Properties();
+unless (open (METACAT_PROPERTIES, $metacatProps)) {
+    #print "Content-type: text/html\n\n";
+    print "Unable to locate Metacat properties. Working directory is set as " . 
+        $workingDirectory .", is this correct?";
+    exit(0);
+}
 
-# 1.8.1 temporary baseUrl fix
-my $baseUrl = "@systemidserver@@servlet-path@";
-$baseUrl =~ s/metacat$//;
+$properties->load(*METACAT_PROPERTIES);
 
+## Set up our default configuration
+my $ldapProps = $properties->splitToTree(qr/\./, 'ldap');
+my $ldapurl = $ldapProps->{'url'};
+my $mainldapurl = $ldapProps->{'mainurl'};
+my $ldapUsername = $ldapProps->{'user'};
+my $ldapPassword = $ldapProps->{'password'};
+my $searchBase = $ldapProps->{'searchbase'};
+my $mailhost = $properties->getProperty('email.mailhost');
+my $sender = $properties->getProperty('email.sender');
+
+# Java uses miliseconds, Perl expects whole seconds
+my $TIMEOUT = $ldapProps->{'connectTimeLimit'} / 1000;
+my $mainldapdownmessage = "The main ldap server $mainldapurl is down!";
+
 # Get the CGI input variables
 my $query = new CGI;
 
@@ -61,10 +74,12 @@
 #--------------------------------------------------------------------------80c->
 # Set up the Template Toolkit to read html form templates
 
+# templates hash, imported from ldap.templates tree in metacat.properties
+my $templates = $properties->splitToTree(qr/\./, 'ldap.templates');
 
 # set some configuration options for the template object
 my $config_templates = {
-             INCLUDE_PATH => $templatesDir, 
+             INCLUDE_PATH => $properties->getProperty('templates-dir'),
              INTERPOLATE  => 0,                    
              POST_CHOMP   => 1,                   
              };
@@ -72,33 +87,26 @@
 # create an instance of the template
 my $template = Template->new($config_templates) || handleGeneralServerFailure($Template::ERROR);
 
-# Read the ldapweb.cfg file
-my $config = AppConfig->new({ 
-    GLOBAL => { ARGCOUNT => ARGCOUNT_ONE, } });
+# custom LDAP properties hash
+my $ldapCustom = $properties->splitToTree(qr/\./, 'ldap');
 
-$config->define("ldapurl", { ARGCOUNT => ARGCOUNT_HASH} );           
-$config->define("ldapsearchbase", { ARGCOUNT => ARGCOUNT_HASH} );
-$config->define("dn", { ARGCOUNT => ARGCOUNT_HASH} );
-$config->define("filter", { ARGCOUNT => ARGCOUNT_HASH} );
-$config->define("user", { ARGCOUNT => ARGCOUNT_HASH} );
-$config->define("password", { ARGCOUNT => ARGCOUNT_HASH} );
+my @orgList = split(/,/, $properties->getProperty('ldap.organizations'));
+my $ldapConfig;
 
-my $cfgfile = "ldapweb.cfg";
-$config->file($cfgfile);
-my $config_ldapurl = $config->get('ldapurl');
-my $config_ldapsearchbase = $config->get('ldapsearchbase');
-my $config_dn = $config->get('dn');
-my $config_filter = $config->get('filter');
-my $config_user = $config->get('user');
-my $config_password = $config->get('password');
+foreach my $o (@orgList) {
+    debug($o);
+    # pull the raw tree in to prevent Perl pass-by-value shenanigans
+    $ldapConfig->{$o} = $properties->splitToTree(qr/\./, 'ldap');
 
-my @orglist;
-foreach my $neworg (keys %$config_dn) {
-    push(@orglist, $neworg);
-    debug($neworg);
+    # override the defaults set in ldap with the custom values
+    if (defined $ldapCustom->{$o}) {
+        my $custom = $ldapCustom->{$o};
+        while (my ($key, $value) = each(%$custom)) {
+            $ldapConfig->{$o}{$key} = $value;
+        }
+    }
 }
 
-
 #--------------------------------------------------------------------------80c->
 # Define the main program logic that calls subroutines to do the work
 #--------------------------------------------------------------------------80c->
@@ -105,15 +113,10 @@
 
 
 # The processing step we are handling
-my $stage = $query->param('stage') || '@defaultStage@';
+my $stage = $query->param('stage') || $templates->{'stage'};
 
 my $cfg = $query->param('cfg');
 
-# 1.8.1 temporary header/footer fixder =
-
-my $header = ($cfg eq 'nceas') ? 'nceasHeader.tmpl' : '@defaultHeader@';
-my $footer = ($cfg eq 'nceas') ? 'nceasFooter.tmpl' : '@defaultFooter@';
-
 # define the possible stages
 my %stages = (
               'initregister'      => \&handleInitRegister,
@@ -149,14 +152,7 @@
 
   print "Content-type: text/html\n\n";
   # process the template files:
-  my $templateVars = { stage => "register", cfg => $cfg };
-  #$$templateVars{'orgList'} = \@orglist;
-  $$templateVars{'orgList'} = \@orglist;
-  $$templateVars{'baseUrl'} = $baseUrl;
-  $template->process( $header, $templateVars);
-  $template->process( "@register@", $templateVars);
-  $template->process( $footer, $templateVars);
-
+  fullTemplate(['register'], {stage => "register"}); 
   exit();
 }
 
@@ -183,20 +179,14 @@
     if (! paramsAreValid(@requiredParams)) {
         my $errorMessage = "Required information is missing. " .
             "Please fill in all required fields and resubmit the form.";
-        my $templateVars = { stage => "register",
-                             cfg => $cfg,
-                             allParams => $allParams,
-                             errorMessage => $errorMessage };
-        $$templateVars{'orgList'} = \@orglist;
-        $$templateVars{'baseUrl'} = $baseUrl;
-        $template->process( $header, $templateVars);
-        $template->process( "@register@", $templateVars);
-        $template->process( $footer, $templateVars);
-        exit(0);
+        fullTemplate(['register'], { stage => "register",
+                                     allParams => $allParams,
+                                     errorMessage => $errorMessage });
+        exit();
     } else {
         my $o = $query->param('o');    
-        $ldapurl = $config_ldapurl->{$o};
-        $searchBase = $config_ldapsearchbase->{$o};  
+        $ldapurl = $ldapConfig->{$o}{'url'};
+        $searchBase = $ldapConfig->{$o}{'base'};  
     }
 
     # Search LDAP for matching entries that already exist
@@ -225,17 +215,9 @@
 
     # If entries match, send back a request to confirm new-user creation
     if ($found) {
-      my $templateVars = { stage => "registerconfirmed",
-                           cfg => $cfg,
-                           allParams => $allParams,
-                           foundAccounts => $found };
-      $$templateVars{'orgList'} = \@orglist;
-      $$templateVars{'baseUrl'} = $baseUrl;
-      $template->process( $header, $templateVars);
-      $template->process( "@registerMatch@", $templateVars);
-      $template->process( "@register@", $templateVars);
-      $template->process( $footer, $templateVars);
-
+      fullTemplate( ['registerMatch', 'register'], { stage => "registerconfirmed",
+                                                     allParams => $allParams,
+                                                     foundAccounts => $found });
     # Otherwise, create a new user in the LDAP directory
     } else {
         #print("ingore create account\n");
@@ -254,8 +236,7 @@
   
     my $allParams = { 'givenName' => $query->param('givenName'), 
                       'sn' => $query->param('sn'),
-                      #'o' => $query->param('o'), 
-                      'o' => 'unaffiliated', 
+                      'o' => 'unaffiliated', # only accept unaffiliated registration
                       'mail' => $query->param('mail'), 
                       'uid' => $query->param('uid'), 
                       'userPassword' => $query->param('userPassword'), 
@@ -264,7 +245,6 @@
                       'telephoneNumber' => $query->param('telephoneNumber') };
     print "Content-type: text/html\n\n";
     createAccount($allParams);
-
     exit();
 }
 
@@ -283,8 +263,8 @@
         $$allParams{'o'} = $query->param('o');
         my $o = $query->param('o');
         
-        $ldapurl = $config_ldapurl->{$o};
-        $searchBase = $config_ldapsearchbase->{$o};
+        $ldapurl = $ldapConfig->{$o}{'url'};
+        $searchBase = $ldapConfig->{$o}{'base'};
     }
 
 
@@ -294,16 +274,10 @@
     if (! paramsAreValid(@requiredParams)) {
         my $errorMessage = "Required information is missing. " .
             "Please fill in all required fields and submit the form.";
-        my $templateVars = { stage => "changepass",
-                             cfg => $cfg,
-                             allParams => $allParams,
-                             errorMessage => $errorMessage };
-        $$templateVars{'orgList'} = \@orglist;
-        $$templateVars{'baseUrl'} = $baseUrl;
-        $template->process( $header, $templateVars);
-        $template->process( "@defaultChangePass@", $templateVars);
-        $template->process( $footer, $templateVars);
-        exit(0);
+        fullTemplate( ['changePass'], { stage => "changepass",
+                                        allParams => $allParams,
+                                        errorMessage => $errorMessage });
+        exit();
     }
 
     # We have all of the info we need, so try to change the password
@@ -310,55 +284,35 @@
     if ($query->param('userPassword') =~ $query->param('userPassword2')) {
 
         my $o = $query->param('o');
-        $ldapurl = $config_ldapurl->{$o};
-        $searchBase = $config_ldapsearchbase->{$o};
-        $root = $config_user->{$o};
-        $rootpw = $config_password->{$o};
+        $ldapurl = $ldapConfig->{$o}{'url'};
+        $searchBase = $ldapConfig->{$o}{'base'};
+        $ldapUsername = $ldapConfig->{$o}{'user'};
+        $ldapPassword = $ldapConfig->{$o}{'password'};
 
-        my $dn = "uid=" . $query->param('uid') . "," . $config_dn->{$o};;
+        my $dn = "uid=" . $query->param('uid') . "," . $ldapConfig->{$o}{'dn'};;
         if ($query->param('o') =~ "LTER") {
-            $template->process( $header);
-            $template->process( "@registerLter@");
-            $template->process( $footer);
+            fullTemplate( ['registerLter'] );
         } else {
             my $errorMessage = changePassword(
                     $dn, $query->param('userPassword'), 
                     $dn, $query->param('oldpass'), $query->param('o'));
             if ($errorMessage) {
-                my $templateVars = { stage => "changepass",
-                                     cfg => $cfg,
-                                     allParams => $allParams,
-                                     errorMessage => $errorMessage };
-                $$templateVars{'orgList'} = \@orglist;
-                $$templateVars{'baseUrl'} = $baseUrl;
-                $template->process( $header, $templateVars);
-                $template->process( "@defaultChangePass@", $templateVars);
-                $template->process( $footer, $templateVars);
-                exit(0);
+                fullTemplate( ['changePass'], { stage => "changepass",
+                                                allParams => $allParams,
+                                                errorMessage => $errorMessage });
+                exit();
             } else {
-                my $templateVars = { stage => "changepass",
-                                     cfg => $cfg,
-                                     allParams => $allParams };
-                $$templateVars{'orgList'} = \@orglist;
-                $$templateVars{'baseUrl'} = $baseUrl;
-                $template->process( $header, $templateVars);
-                $template->process( "@changePassSuccess@", $templateVars);
-                $template->process( $footer, $templateVars);
-                exit(0);
+                fullTemplate( ['changePassSuccess'], { stage => "changepass",
+                                                       allParams => $allParams });
+                exit();
             }
         }
     } else {
         my $errorMessage = "The passwords do not match. Try again.";
-        my $templateVars = { stage => "changepass",
-                             cfg => $cfg,
-                             allParams => $allParams,
-                             errorMessage => $errorMessage };
-        $$templateVars{'orgList'} = \@orglist;
-        $$templateVars{'baseUrl'} = $baseUrl;
-        $template->process( $header, $templateVars);
-        $template->process( "@defaultChangePass@", $templateVars);
-        $template->process( $footer, $templateVars);
-        exit(0);
+        fullTemplate( ['changePass'], { stage => "changepass",
+                                        allParams => $allParams,
+                                        errorMessage => $errorMessage });
+        exit();
     }
 }
 
@@ -371,16 +325,9 @@
 
     my $allParams = { 'test' => "1", };
     my $errorMessage = "";
-    my $templateVars = { stage => "changepass",
-                         cfg => $cfg,
-                         allParams => $allParams,
-                         errorMessage => $errorMessage };
-    $$templateVars{'orgList'} = \@orglist;
-    $$templateVars{'baseUrl'} = $baseUrl;
-    $template->process( $header, $templateVars);
-    $template->process( "@defaultChangePass@", $templateVars);
-    $template->process( $footer, $templateVars);
-    exit(0);
+    fullTemplate( ['changePass'], { stage => "changepass",
+                                    errorMessage => $errorMessage });
+    exit();
 }
 
 #
@@ -398,10 +345,10 @@
         $$allParams{'o'} = $query->param('o');
         my $o = $query->param('o');
         
-        $ldapurl = $config_ldapurl->{$o};
-        $searchBase = $config_ldapsearchbase->{$o};
-        $root = $config_user->{$o};
-        $rootpw = $config_password->{$o};
+        $ldapurl = $ldapConfig->{$o}{'url'};
+        $searchBase = $ldapConfig->{$o}{'base'};
+        $ldapUsername = $ldapConfig->{$o}{'user'};
+        $ldapPassword = $ldapConfig->{$o}{'password'};
     }
 
     # Check that all required fields are provided and not null
@@ -409,26 +356,18 @@
     if (! paramsAreValid(@requiredParams)) {
         my $errorMessage = "Required information is missing. " .
             "Please fill in all required fields and submit the form.";
-        my $templateVars = { stage => "resetpass",
-                             cfg => $cfg,
-                             allParams => $allParams,
-                             errorMessage => $errorMessage };
-        $$templateVars{'orgList'} = \@orglist;
-        $$templateVars{'baseUrl'} = $baseUrl;
-        $template->process( $header, $templateVars);
-        $template->process( "@defaultResetPass@", $templateVars);
-        $template->process( $footer, $templateVars);
-        exit(0);
+        fullTemplate( ['resetPass'],  { stage => "resetpass",
+                                        allParams => $allParams,
+                                        errorMessage => $errorMessage });
+        exit();
     }
 
     # We have all of the info we need, so try to change the password
     my $o = $query->param('o');
-    my $dn = "uid=" . $query->param('uid') . "," . $config_dn->{$o};
+    my $dn = "uid=" . $query->param('uid') . "," . $ldapConfig->{$o}{'dn'};
     if ($query->param('o') =~ "LTER") {
-        $template->process( $header);
-        $template->process( "@registerLter@");
-        $template->process( $footer);
-        exit(0);
+        fullTemplate( ['registerLter'] );
+        exit();
     } else {
         my $errorMessage = "";
         my $recipient;
@@ -439,35 +378,23 @@
         if ($entry) {
             $recipient = $entry->get_value('mail');
             $userPass = getRandomPassword();
-            $errorMessage = changePassword($dn, $userPass, $root, $rootpw, $query->param('o'));
+            $errorMessage = changePassword($dn, $userPass, $ldapUsername, $ldapPassword, $query->param('o'));
         } else {
             $errorMessage = "User not found in database.  Please try again.";
         }
 
         if ($errorMessage) {
-            my $templateVars = { stage => "resetpass",
-                                 cfg => $cfg,
-                                 allParams => $allParams,
-                                 errorMessage => $errorMessage };
-            $$templateVars{'orgList'} = \@orglist;
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( $header, $templateVars);
-            $template->process( "@defaultResetPass@", $templateVars);
-            $template->process( $footer, $templateVars);
-            exit(0);
+            fullTemplate( ['resetPass'], { stage => "resetpass",
+                                           allParams => $allParams,
+                                           errorMessage => $errorMessage });
+            exit();
         } else {
             my $errorMessage = sendPasswordNotification($query->param('uid'),
                     $query->param('o'), $userPass, $recipient, $cfg);
-            my $templateVars = { stage => "resetpass",
-                                 cfg => $cfg,
-                                 allParams => $allParams,
-                                 errorMessage => $errorMessage };
-            $$templateVars{'orgList'} = \@orglist;
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( $header, $templateVars);
-            $template->process( "@resetPassSuccess@", $templateVars);
-            $template->process( $footer, $templateVars);
-            exit(0);
+            fullTemplate( ['resetPassSuccess'], { stage => "resetpass",
+                                                  allParams => $allParams,
+                                                  errorMessage => $errorMessage });
+            exit();
         }
     }
 }
@@ -479,17 +406,9 @@
 sub handleInitialResetPassword {
     print "Content-type: text/html\n\n";
     my $errorMessage = "";
-    my $allParams = { 'test' => "1", };
-    my $templateVars = { stage => "resetpass",
-                         cfg => $cfg,
-                         allParams => $allParams,
-                         errorMessage => $errorMessage };
-    $$templateVars{'orgList'} = \@orglist;
-    $$templateVars{'baseUrl'} = $baseUrl;
-    $template->process( $header, $templateVars);
-    $template->process( "@defaultResetPass@", $templateVars);
-    $template->process( $footer, $templateVars);
-    exit(0);
+    fullTemplate( ['resetPass'], { stage => "resetpass",
+                                   errorMessage => $errorMessage });
+    exit();
 }
 
 #
@@ -517,8 +436,8 @@
     my $bindPass = shift;
     my $o = shift;
 
-    my $ldapurl = $config_ldapurl->{$o};
-    my $searchBase = $config_ldapsearchbase->{$o};
+    my $ldapurl = $ldapConfig->{$o}{'url'};
+    my $searchBase = $ldapConfig->{$o}{'base'};
     
     my $errorMessage = 0;
     my $ldap;
@@ -601,9 +520,9 @@
         return $entry;
     }
 
-    if($config_filter->{$org}){
+    if($ldapConfig->{$org}{'filter'}){
         $mesg = $ldap->search ( base   => $base,
-                filter => "(&(uid=$username)($config_filter->{$org}))");
+                filter => "(&(uid=$username)($ldapConfig->{$org}{'filter'}))");
     } else {
         $mesg = $ldap->search ( base   => $base, filter => "(uid=$username)");
     }
@@ -655,7 +574,7 @@
         This is generally done when somebody forgets their password.  Your 
         password can be changed by visiting the following URL:
 
-        @cgiurl@?stage=changepass&cfg=$cfg
+        $cgiUrl?stage=changepass&cfg=$cfg
 
             Username: $username
         Organization: $org
@@ -770,34 +689,25 @@
     my $allParams = shift;
 
     if ($query->param('o') =~ "LTER") {
-        $template->process( $header);
-        $template->process( "@registerLter@");
-        $template->process( $footer);
+        fullTemplate( ['registerLter'] );
     } else {
 
         # Be sure the passwords match
         if ($query->param('userPassword') !~ $query->param('userPassword2')) {
             my $errorMessage = "The passwords do not match. Try again.";
-            my $templateVars = { stage => "register",
-                                 cfg => $cfg,
-                                 allParams => $allParams,
-                                 errorMessage => $errorMessage };
-            $$templateVars{'orgList'} = \@orglist;
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( $header, $templateVars);
-            $template->process( "@registerFailed@", $templateVars);
-            $template->process( "@register@", $templateVars);
-            $template->process( $footer, $templateVars);
-            exit(0);
+            fullTemplate( ['registerFailed', 'register'], { stage => "register",
+                                                            allParams => $allParams,
+                                                            errorMessage => $errorMessage });
+            exit();
         }
 
         my $o = $query->param('o');
 
-        my $ldapurl = $config_ldapurl->{$o};
-        my $root = $config_user->{$o};
-        my $rootpw = $config_password->{$o};
-        my $searchBase = $config_ldapsearchbase->{$o};
-        my $dnBase = $config_dn->{$o};
+        my $ldapurl = $ldapConfig->{$o}{'url'};
+        my $ldapUsername = $ldapConfig->{$o}{'user'};
+        my $ldapPassword = $ldapConfig->{$o}{'password'};
+        my $searchBase = $ldapConfig->{$o}{'base'};
+        my $dnBase = $ldapConfig->{$o}{'dn'};
 
         
         #if main ldap server is down, a html file containing warning message will be returned
@@ -805,7 +715,7 @@
         
         
         $ldap->start_tls( verify => 'none');
-        $ldap->bind( version => 3, dn => $root, password => $rootpw );
+        $ldap->bind( version => 3, dn => $ldapUsername, password => $ldapPassword );
         #print "Inserting new entry...\n";
         my $dn = 'uid=' . $query->param('uid') . ',' . $dnBase;
 
@@ -840,27 +750,15 @@
         my $result = $ldap->add ( 'dn' => $dn, 'attr' => [ @$additions ]);
     
         if ($result->code()) {
-            my $templateVars = { stage => "register",
-                                 cfg => $cfg,
-                                 allParams => $allParams,
-                                 errorMessage => $result->error };
-            $$templateVars{'orgList'} = \@orglist;
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( $header, $templateVars);
-            $template->process( "@registerFailed@", $templateVars);
-            $templateVars    = { stage => "register",
-                                 cfg => $cfg,
-                                 allParams => $allParams };
-            $$templateVars{'orgList'} = \@orglist;
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( "@register@", $templateVars);
-            $template->process( $footer, $templateVars);
+            fullTemplate( ['registerFailed', 'register'], { stage => "register",
+                                                            allParams => $allParams,
+                                                            errorMessage => $result->error });
+            # TODO SCW was included as separate errors, test this
+            #$templateVars    = setVars({ stage => "register",
+            #                     allParams => $allParams });
+            #$template->process( $templates->{'register'}, $templateVars);
         } else {
-            my $templateVars    = { cfg => $cfg };
-            $$templateVars{'baseUrl'} = $baseUrl;
-            $template->process( $header, $templateVars);
-            $template->process( "@registerSuccess@", $templateVars);
-            $template->process( $footer, $templateVars);
+            fullTemplate( ['success'] );
         }
 
         $ldap->unbind;   # take down session
@@ -872,14 +770,9 @@
   print "Content-type: text/html\n\n";
   my $errorMessage = "You provided invalid input to the script. " .
                      "Try again please.";
-  my $templateVars = { stage => "@defaultStage@",
-                       cfg => $cfg,
-                       errorMessage => $errorMessage };
-  $$templateVars{'orgList'} = \@orglist;
-  $$templateVars{'baseUrl'} = $baseUrl;
-  $template->process( $header, $templateVars);
-  $template->process( $footer, $templateVars);
-  exit(0);
+  fullTemplate( [], { stage => $templates->{'stage'},
+                      errorMessage => $errorMessage });
+  exit();
 }
 
 #
@@ -891,8 +784,8 @@
 
     my $o = $query->param('o');
 
-    my $ldapurl = $config_ldapurl->{$o};
-    my $searchBase = $config_ldapsearchbase->{$o};
+    my $ldapurl = $ldapConfig->{$o}{'url'};
+    my $searchBase = $ldapConfig->{$o}{'base'};
 
     print "Content-type: text/html\n\n";
 
@@ -934,29 +827,15 @@
 
     # Send back the search results
     if ($found) {
-      my $templateVars = { stage => "searchResults",
-                           cfg => $cfg,
-                           allParams => $allParams,
-                           foundAccounts => $found };
-      $$templateVars{'orgList'} = \@orglist;
-      $$templateVars{'baseUrl'} = $baseUrl;
-      $template->process( $header, $templateVars);
-      $template->process( "@searchResults@", $templateVars);
-      $template->process( $footer, $templateVars);
-
+      fullTemplate( ('searchResults'), { stage => "searchresults",
+                                         allParams => $allParams,
+                                         foundAccounts => $found });
     } else {
       $found = "No entries matched your criteria.  Please try again\n";
 
-      my $templateVars = { stage => "searchResults",
-                           cfg => $cfg,
-                           allParams => $allParams,
-                           foundAccounts => $found };
-      $$templateVars{'orgList'} = \@orglist;
-      $$templateVars{'baseUrl'} = $baseUrl;
-      $template->process( $header, $templateVars);
-      $template->process( "@searchResults@", $templateVars);
-      $template->process( $footer, $templateVars);
-
+      fullTemplate( ('searchResults'), { stage => "searchresults",
+                                         allParams => $allParams,
+                                         foundAccounts => $found });
     }
 
     exit();
@@ -1035,13 +914,36 @@
 
 sub handleGeneralServerFailure {
     my $errorMessage = shift;
-    my $templateVars = { cfg => $cfg,
-                         errorMessage => $errorMessage };
-    $$templateVars{'baseUrl'} = $baseUrl;
-    $template->process( $header, $templateVars);
-    $template->process( "@ldapMainServerFailure@", $templateVars);
-    $template->process( $footer, $templateVars);
+    fullTemplate( ('mainServerFailure'), { errorMessage => $errorMessage });
     exit(0);   
    }
     
+sub setVars {
+    my $paramVars = shift;
+    # initialize default parameters 
+    my $templateVars = { cfg => $cfg,
+                         styleSkinsPath => $properties->getProperty('style-skins-path'),
+                         styleCommonPath => $properties->getProperty('style-common-path'),
+                         baseUrl => $properties->getProperty('baseUrl'),
+                         orgList => \@orgList,
+    };
+    
+    # append customized params
+    while (my ($k, $v) = each (%$paramVars)) {
+        $templateVars->{$k} = $v;
+    }
+    
+    return $templateVars;
+} 
+    
+sub fullTemplate {
+    my $templateList = shift;
+    my $templateVars = setVars(shift);
 
+    $template->process( $templates->{'header'}, $templateVars );
+    
+    foreach my $tmpl (@{$templateList}) {
+        $template->process( $templates->{$tmpl}, $templateVars );
+    }    
+    $template->process( $templates->{'footer'}, $templateVars );
+}
Index: src/edu/ucsb/nceas/metacat/ElementNode.java
===================================================================
--- src/edu/ucsb/nceas/metacat/ElementNode.java	(revision 4079)
+++ src/edu/ucsb/nceas/metacat/ElementNode.java	(revision 4080)
@@ -53,8 +53,6 @@
    */
   public ElementNode (TreeSet nodeRecordList, long nodeid) {
 
-    MetaCatUtil util = new MetaCatUtil();
-
     // Step through all of the node records we were given
     Iterator it = nodeRecordList.iterator();
     while (it.hasNext()) {
